package hex

import java.io.File

fun hexing() {
    val v1 = File("/home/blint/projects/bme-vi/itsec/two-square/LabProfile-v1.crypt")
        .readBytes()
        .asUnsigned()
        .toBlocks(16)
        .drop(8)

    val v1_1 = File("/home/blint/projects/bme-vi/itsec/two-square/LabProfile-v1.1.crypt")
        .readBytes()
        .asUnsigned()
        .toBlocks(16)
        .drop(8)

    val xoredBlocks = v1 xor v1_1
    val decodedBlocks = mutableListOf<List<Int>>()
    var lastDecoded = List(16) { 0x20 }
    var decodedString = ""

    for (element in xoredBlocks) {
        lastDecoded = element xor lastDecoded
        decodedBlocks += lastDecoded
        decodedString += lastDecoded.toASCII()
    }

    println(decodedString)

    // print last 4 unprintable char
    for (i in 12..15) {
        print(lastDecoded[i].toString(16).padStart(2, '0'))
    }
    println()
}

fun ByteArray.asUnsigned() :List<Int> {
    val hexList: MutableList<Int> = mutableListOf()
    this.forEach { byte -> hexList.add(byte.toInt() and 0xFF) }
    return hexList
}

fun List<Int>.toBlocks(blockSize: Int) : List<List<Int>> {
    val retList = mutableListOf<List<Int>>()
    repeat(this.size / blockSize) {
        retList += this.subList(it * blockSize, (it + 1) * blockSize)
    }
    return retList
}

fun List<List<Int>>.drop(n: Int) : List<List<Int>> {
    return this.subList(n, this.size)
}

fun List<Int>.toASCII(): String {
    var ret = ""
    for (i in this) {
        ret += i.toChar()
    }
    return ret
}

infix fun List<Int>.xor(l : List<Int>) : List<Int> {
    var retList = mutableListOf<Int>()
    repeat(minOf(this.size, l.size)) {
        retList.add(this[it] xor l[it])
    }
    return retList
}

@JvmName("xorInt")
infix fun List<List<Int>>.xor(l: List<List<Int>>) : List<List<Int>> {
    val xoredBlocks = mutableListOf<List<Int>>()
    repeat(minOf(this.size, l.size)) {
        xoredBlocks += this[it] xor l[it]
    }
    return xoredBlocks
}